import { r as registerInstance, h, g as getElement } from './core-095fd691.js';
import { B as Block } from './block-89b88b6d.js';
import { l as linker } from './input-linker-2b74e80e.js';
import { E as ElementQuestionBase } from './element-question-base-5de5ce16.js';

const BceElementSmileyTemplate = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.metadata = {};
        this.optionIcon = Block.ICON_MAP['icon'];
        this.question = '';
        this.required = false;
        this.options = [
            { text: 'fas:sad-tear', color: '#ef8b54' },
            { text: 'fas:frown-open', color: '#f3ac4c' },
            { text: 'fas:meh', color: '#f6d24c' },
            { text: 'fas:grin', color: '#d7f18e' },
            { text: 'fas:laugh', color: '#aad77e' }
        ];
        this.labelQuestion = 'Formulate your question';
        this.labelRequired = 'Required';
        this.labelOCAddButton = 'Add';
        this.labelOCRemoveButton = 'Delete';
        this.labelOCOther = 'Other';
        this.labelOCImage = 'Image';
        this.placeholderOptions = 'Icon';
        this._link = linker(this, this.handleInput);
        this._question = this._link('question');
        this._required = this._link('required');
        this._options = this._link('options');
    }
    handleInput(name, event) {
        const input = event.target;
        if (!input)
            return;
        event.cancelBubble = true;
        this[name] = input.value;
        this.value = this.updateValue({ [name]: input.value });
        this.el.dispatchEvent(new Event('input', { bubbles: true }));
    }
    updateValue(part = {}) {
        const current = {
            question: this.question,
            required: this.required,
            options: this.options,
            metadata: Object.assign({}, this.metadata)
        };
        return Object.assign({}, current, part);
    }
    componentDidLoad() {
        this.value = this.updateValue();
        this.el.dispatchEvent(new Event('input', { bubbles: true }));
    }
    render() {
        const options = Object.assign({ icon: this.options.map(o => o.text || this.optionIcon), labelOCAddButton: this.labelOCAddButton, labelOCRemoveButton: this.labelOCRemoveButton, labelOCOther: this.labelOCOther, labelOCImage: this.labelOCImage, allowImage: false, allowColor: true }, this._options);
        return (h(ElementQuestionBase, { question: this._question, required: this._required }, h("bce-option-creator", Object.assign({}, options))));
    }
    get el() { return getElement(this); }
};

export { BceElementSmileyTemplate as bce_element_icon_template };
